// ombFilter.h: interface for the CombFilter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMBFILTER_H__0BBB7320_9D8B_11DA_9957_00045A579F34__INCLUDED_)
#define AFX_COMBFILTER_H__0BBB7320_9D8B_11DA_9957_00045A579F34__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CombFilter  
{
public:
	CombFilter();
	virtual ~CombFilter();

			void	setbuffer(float *buf, int size);
	inline  float	process(float inp);
			void	mute();
			void	setdamp(float val);
			void	setfeedback(float val);
private:
	float	feedback;
	float	filterstore;
	float	damp1;
	float	damp2;
	float	*buffer;
	int		bufsize;
	int		bufidx;

};


inline float CombFilter::process(float input)
{
	float output;

	output = buffer[bufidx];
//	undenormalise(output);
	if(((*(unsigned int*)&output)&0x7f800000)==0) output=0.0f;	

	filterstore = (output*damp2) + (filterstore*damp1);

	//	undenormalise(filterstore);

	if(((*(unsigned int*)&filterstore)&0x7f800000)==0) filterstore=0.0f;


//	filterstore = (output);

	buffer[bufidx] = input + (filterstore*feedback);

	if(++bufidx>=bufsize) bufidx = 0;

	return output/2;
}


#endif // !defined(AFX_COMBFILTER_H__0BBB7320_9D8B_11DA_9957_00045A579F34__INCLUDED_)
