#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"
#include "AllFilter.h"
#include "CombFilter.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void open();

private:
	int static_count;

	float SamplesPerSec;

	float *in,*in_buffer;
	float *out,*out_buffer;
    float vout;

	long tcount;

    void StartUp();
	void SetSleepMode(state_type out_stat);
	bool sleepmode;


    float Reverb_Amount,*reverb_amount_buffer;
	float Reverb_Time,*reverb_time_buffer;

  	float *prebuffer[2],pd1,pd2;
	unsigned long precount[2];
	unsigned long prebuffer_size[2];
  

	bool Reverb_On;
    void Reverb_UpdateAmount();
	void Reverb_UpdateTime();
    void Reverb_CreatePreBuffer();

    float groupa,groupb,wetouta,wetoutb;

	CombFilter	comba[4];
	CombFilter	combb[4];

	// Allpass filters
	AllFilter	allpassa[2];
	AllFilter	allpassb[2];

	// Buffers for the combs
	float	bufcomba1[1116*2];
	float	bufcomba2[1277*2];
	float	bufcomba3[1422*2];
	float	bufcomba4[1577*2];


	float	bufcombb1[1188*2];
	float	bufcombb2[1356*2];
	float	bufcombb3[1491*2];
	float	bufcombb4[1617*3];


	// Buffers for the allpasses
	float	bufallpassa1[556*2];
	float	bufallpassa2[341*2];

	float	bufallpassb1[441*2];
	float	bufallpassb2[225*2];


};
#endif
